#include <EEPROM.h>
#include <OneWire.h>
#include <DallasTemperature.h>
//#include <LiquidCrystal.h>
#include "LiquidCrystal_1602_RUS.h"

OneWire  oneWire(2); 
DallasTemperature ds(&oneWire);
//LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
LiquidCrystal_1602_RUS lcd(8, 9, 4, 5, 6, 7);


const byte OUT[5] = {13, 12, 11, 3, 22}; // номера выходов 
// 12 клапан термостат
// 11 пищалка
// 2 циф вход датчиков 18b20

float tempOUTon[5];  // массив с температурой включения выхода
float tempOUTonGO[5];  // массив с температурой включения выхода 
float tempOUTonHV[5];  // массив с температурой включения выхода
float tempSensor[5]; // массив куда читается температура
float t;// массив значение которого выше на 0,3 чем tempOUTon[0]

int realI = 0; // получаемое от ардуино МИНИ значение реального тока
int I = 0; //значение тока для отправки на ардуино мини
int i = 0; // константа для расчетов значений тока
int WT = 0; // реальная мощность подаваемая на тэн

byte qty; // количество градусников на шине.


int Wt; //мощность отбор тела храниться в EEPROM
int WtPR; // мощность прямой перегон храниться в EEPROM
int WtGO; //мощность отбор голов храниться в EEPROM
int WtHV; // мощность отбор хвостов храниться в EEPROM

int item = 0; //номер экрана меню
int menuLevel=3;// режим работы (сырец, голова, тело или хвост)храниться в EEPROM

long previousMillis = 0;        // храним время последнего включения кнопки 
long interval = 200;           // интервал между включениями кнопок (300 миллисекунд)

unsigned long time; // таймеры
unsigned long previousMillisI = 0;
unsigned long previousMillis1 = 0;
unsigned long previousMillis2 = 0;

int Tsensorf = 0 ;// флаг тревоги при отсутствии датчика t1
int Tsensorh = 0 ;// флаг тревоги при отсутствии датчика t2
int Tsensorj = 0;// флаг тревоги при отсутствии датчика t3
int g=50; // предел для включения тревоги по отсутствию датчика t
int f=0;//переменная для расчета (t1)
int h=0;// переменная для расчета (t2)
int j=0;//переменная для расчета (t3)

// адреса датчиков t
DeviceAddress sensor1 = {0x28, 0xFF, 0x94, 0xC8, 0x92, 0x16, 0x04, 0x85};
DeviceAddress sensor2 = {0x28, 0xFF, 0x81, 0xC5, 0x92, 0x16, 0x04, 0xB6};
DeviceAddress sensor3 = {0x28, 0xFF, 0xE9, 0xC6, 0x92, 0x16, 0x04, 0x11};
DeviceAddress sensor4 = {0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
DeviceAddress sensor5 = {0x28, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};


void readSet(){ // считываем EEPROM по сохраненной температуре и мощности

  EEPROM.get(0, tempOUTon[0]);
  EEPROM.get(8, tempOUTon[1]);
  EEPROM.get(15, tempOUTon[2]);
  EEPROM.get(20, Wt); // значение мощности
  EEPROM.get(25, menuLevel); // выбор режима (тело или голова)
  EEPROM.get(30, WtPR); // значение мощности прямой перегон
  EEPROM.get(35, WtGO); // значение мощности отбор голов
  EEPROM.get(40, WtHV); // значение мощности отбор хвостов
  EEPROM.get(45, tempOUTonGO[0]);
  EEPROM.get(50, tempOUTonGO[0]);
  EEPROM.get(55, tempOUTonGO[0]);
  EEPROM.get(60, tempOUTonHV[0]);


  
}
void getTemp(){ // читаем температуру с датчиков и заполняем массив
   ds.requestTemperatures();    
   
   tempSensor[0] = ds.getTempC(sensor1); // немного китайского кода
   tempSensor[1] = ds.getTempC(sensor2); 
   tempSensor[2] = ds.getTempC(sensor3);
   tempSensor[3] = ds.getTempC(sensor4);
   tempSensor[4] = ds.getTempC(sensor5);
} 

//void sensorTest(){  // ищим датчики на шине, // если количество изменилось, останавливаем работу  //      1          11111111111111111111111111111111111111111
   //ds.begin();                                                                                    // 11111111111111111111111111111111111111111111111111111111
   //if(ds.getDeviceCount() != qty)  erorr();
//}                                                                                                 //111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
  //void erorr(){ // останавливает работу программы и сигнализирует ошибку
 // outOff(); // выключаем выходы    
 // lcd.clear();
 // lcd.print("sensor error");
   // while(1){ // крутим бесконечный цикл
      //analogWrite(10, 100);
     // delay(300);
      //analogWrite(10, 255);
     // delay(300);
  //}
//}

byte Key(){// проверяем кнопки шилда
  if (analogRead(0) < 50) return 3; // вправо
  else if (analogRead(0) < 180) return 2; //вниз
  else if (analogRead(0) < 350) return 4;// вверх
  else if (analogRead(0) < 550) return 1; // влево
  else if (analogRead(0) < 800) return 5; //sekect
  else if (analogRead(0) < 1023) return 0;
}




void setup() {
  Serial.begin(9600);
  Serial2.begin(9600);
  Serial3.begin(9600);
  
ds.begin(); 
ds.setResolution(sensor1, 12); // определяем разрешение датчика температуры
ds.setResolution(sensor2, 12);
ds.setResolution(sensor3, 11);
ds.setResolution(sensor4, 9);
ds.setResolution(sensor5, 9);
    
  qty = ds.getDeviceCount(); // при включении, сохраняем количество градусников, 
                             // можно и лучше количество указать руками. 

  lcd.begin(16, 2);  // включаем экран
  lcd.clear();       // очищаем экран
 
     for (int i = 0; i < qty; i++) pinMode(OUT[i], OUTPUT);  
  for (int i = 0; i < qty; i++) digitalWrite(OUT[i], LOW);
}

void loop(){
	
  //убираем дребезг кнопок
  byte KEY;
 //  unsigned long currentMillis = millis();
   if (millis() - previousMillis >= interval) {
    previousMillis = millis(); 
     KEY = Key();}
     
  //sensorTest(); // тест наличия градусников на шине // 1111111111111111111111111111111111111111111
 // getTemp(); // читаем температуру с датчиков   //1111111111111111111111111111111111111111111
  readSet();  // читаем настройки из еепром    

  if (KEY == 0)  getTemp();// если нажимается кнопка, температура не считывается  //11111111111111111111111111111
  
  // если датчик t не подключен на экране показания равны 0 //Tsensor флаг ошибки по отсутствию датчика
   if (tempSensor[0] < 0) 
   {
  tempSensor[0] = 0; 
   f++;
   if (f > g) Tsensorf = 1;// если датчика нет несколько секунд, появляется ошибка   
}
else {
  Tsensorf = 0;// иначе ошибки нет
f=0;
}

if (tempSensor[1] < 0)  {
tempSensor[1] = 0; 
    h++;
   if (h > g) Tsensorh = 1;
}
else {
  Tsensorh = 0;
h=0;
}

if (tempSensor[2] < 0)  {
 tempSensor[2] = 0; 
    j++;
   if (j > g) Tsensorj = 1;
}
else {
  Tsensorj = 0;
j=0;
}

  
  /////// вывод инфы на экран



//___________ТЕЛО___________________________________________________________________________________________________________________________________________


  //  работа в режиме отбор тела
  
  if (item == 0 && menuLevel == 3) 
  {
  lcd.setCursor(0, 0); 
  lcd.print (tempSensor[0], 1);  // показываем температуру с датчика царги
  lcd.setCursor(5, 0); 
  lcd.print (tempSensor[1], 1);  // показываем температуру с датчика дефа
  lcd.setCursor(10, 0); 
  lcd.print (tempSensor[2], 1);  // показываем температуру с датчика куба
  lcd.setCursor(0, 1);
  lcd.print(tempOUTon[0], 1); // показываем установленную температуру дельты
  long time=millis()/1000;
  lcd.setCursor(5, 1); 
  if ((time/60/60)%60<10) {  lcd.print ("0"); }
  lcd.print (time/60/60);  // час
  lcd.setCursor(7, 1);
  if (time%2 == 1)  lcd.print (":");  
  else   lcd.print (" ");   
  lcd.setCursor(8, 1); 
  if (time/60%60<10) {  lcd.print ("0"); }
  lcd.print ((time/60)%60); 
  
  if (Serial2.available() > 0) {// вывод на экран реальной мощности
  realI = Serial2.read();  
  WT = realI * 22;       
  lcd.setCursor(11, 1);
  lcd.print (WT);
  lcd.print ("W");
  lcd.print ("    ");  
  }
 
  //// сверяем температуру и управляем выходами

  if (tempSensor[0] >= tempOUTon[0] && tempSensor[1] >= tempOUTon[1])  digitalWrite(OUT[1], HIGH); // включение клапана
  else digitalWrite(OUT[1], LOW);
  
  // включение пищалки
  t = tempOUTon[0] + 0.3; // значение для включения тревоги при превышении дельты на 0,3 градуса
  if (tempSensor[1] >= tempOUTon[2] || tempSensor[2] >= 99 || tempSensor[0] > t || Tsensorf == 1 || Tsensorh == 1 || Tsensorj == 1)// сенсор 1 температура в самом вверху колонны,// сенсор2 темпер куба.// порог срабатывания тревоги при превышении на 0,3градуса
 { 
  tone(OUT[2], 2000, 300); // включаем пищалку
  delay (300);
  digitalWrite(OUT[3], HIGH); 
  if (millis() - previousMillis1 >= 1000) { // расчет мощности и отправка значения на МИНИ
  previousMillis1 = millis(); 
  I = 0; // вычисляем значение тока с округлением  
  Serial2.write(I); // передаем значение на ардумини
 } 
}
  else     
 {
  noTone(OUT[2]);// выключаем пищалку
  digitalWrite(OUT[3], LOW);
  if (millis() - previousMillis1 >= 1000) { // расчет мощности и отправка значения на МИНИ
  previousMillis1 = millis(); 
  I = round(Wt/22); // вычисляем значение тока с округлением  
  Serial2.write(I); // передаем значение на ардумини
 } 
}
 // передаем значения для блютуза
  if (millis() - previousMillis2 >= 1000) { // расчет мощности и отправка значения на МИНИ
  previousMillis2 = millis(); 
  Serial3.print("Td  ");
  Serial3.println(tempOUTon[0], 1);
  Serial3.print("t1  ");
  Serial3.println(tempSensor[0], 1);
  Serial3.print("t2  ");
  Serial3.println(tempSensor[1], 1);
  Serial3.print("t3  ");
  Serial3.println(tempSensor[2], 1);
  Serial3.print(WT);
  Serial3.println("w  ");
  Serial3.println("  ");

 }
  // статус работающей системы
   lcd.setCursor(15, 0);        
   if (digitalRead(OUT[3])) lcd.print("!"); // статус тревога
   if (digitalRead(OUT[1])) lcd.print(L"К");// статус открыт клапан
   else  if (menuLevel == 1) lcd.print(L"С");// режим отбора сырца
   else  if (menuLevel == 2) lcd.print(L"Г");// режим отбора голов
   else  if (menuLevel == 3) lcd.print(L"Т");// режим отбора тела
   else  if (menuLevel == 4) lcd.print(L"Х");// режим отбора хвостов 
  
  // выбор температуры дельты клапана  
    if (KEY == 4) { // если нажата кнопка
      tempOUTon[0]=tempOUTon[0]-0.1;   // изменяем значение
        if (tempOUTon[0] < 60) tempOUTon[0] = 101;
        if (tempOUTon[0] > 101) tempOUTon[0] = 60;
      EEPROM.put(0, tempOUTon[0]); // сохраняем в еепром
     }
     
     else if (KEY == 2){
       tempOUTon[0]=tempOUTon[0]+0.1;
         if (tempOUTon[0] > 101) tempOUTon[0] = 60;
         if (tempOUTon[0] < 60) tempOUTon[0] = 101;
          EEPROM.put(0, tempOUTon[0]); 
     } 
       
    else if (KEY == 3){//  шагаем следующее меню
     item = 1;
     lcd.clear();
     } 
      else if (KEY == 5){ // кнопка селект выбор головы или тело
      item = 10;
      lcd.clear();
     }       
  }
  
//НАСТРОЙКА ПАРАМЕТРОВ для режима отбор тела__________________________________________________________________

 else if (item == 1 && menuLevel == 3) // настройка температуры отключения клапана по t дефа
  {    
    lcd.setCursor(0, 0);
    lcd.print(L"Т ниж порог клап"); 
    lcd.setCursor(0, 1);
    lcd.print(" "); 
    lcd.print(tempOUTon[1], 1);
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      tempOUTon[1]=tempOUTon[1]-0.1;   // изменяем значение
        if (tempOUTon[1] < 60) tempOUTon[1] = 101;
        if (tempOUTon[1] > 101) tempOUTon[1] = 60;
      EEPROM.put(8, tempOUTon[1]); // сохраняем в еепром
     }
     else if (KEY == 2){
       tempOUTon[1]=tempOUTon[1]+0.1;
         if (tempOUTon[1] > 101) tempOUTon[1] = 60;
         if (tempOUTon[1] < 60) tempOUTon[1] = 101;
          EEPROM.put(8, tempOUTon[1]); 
     }
       else if (KEY == 1){
      item = 0;
     lcd.clear();
     } 
        else if (KEY == 3){
      item = 3; // пока вместо 2 поставил 3, пропущу "Мах Т колонны"
     lcd.clear();
     } 
 }
  //___________________________________________________________________________________
  else if (item == 2 && menuLevel == 3) //температура out2 // тревога перегрев колонна
  {
    lcd.setCursor(0, 0);
    lcd.print(L"Мах Т колонны"); 
    lcd.setCursor(0, 1);
    lcd.print(" "); 
    lcd.print(tempOUTon[2], 1);
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      tempOUTon[2]=tempOUTon[2]-0.1;   // изменяем значение
        if (tempOUTon[2] < 60) tempOUTon[2] = 101;
        if (tempOUTon[2] > 101) tempOUTon[2] = 60;
      EEPROM.put(15, tempOUTon[2]); // сохраняем в еепром
     }
     else if (KEY == 2){
       tempOUTon[2]=tempOUTon[2]+0.1;
         if (tempOUTon[2] > 101) tempOUTon[2] = 60;
         if (tempOUTon[2] < 60) tempOUTon[2] = 101;
          EEPROM.put(15, tempOUTon[2]); 
     }
       else if (KEY == 1){
      item = 1;
     lcd.clear();
     } 
        else if (KEY == 3){
      item = 3;
     lcd.clear();
     } 
    }
    
  // ___________________________________________________________________________________________ 
  else if (item == 3 && menuLevel == 3) //температура out2 //первый экран и выбран 2 элемент
  {
    lcd.setCursor(0, 0);
    lcd.print(L"Мощность тэна"); 
    lcd.setCursor(0, 1);
    lcd.print(" "); 
    lcd.print(Wt);
    lcd.print("Wt  "); 
  
    // изменение мощности
    if (KEY == 4) { // если нажата кнопка
      Wt=Wt-20;   // изменяем значение
       if (Wt < 10) Wt = 2500;
        if (Wt > 2500) Wt = 10;
      EEPROM.put(20, Wt); // сохраняем в еепром
     }
     
     else if (KEY == 2){
       Wt=Wt+20;
        if (Wt < 10) Wt = 2500;
        if (Wt > 2500) Wt = 10;
          EEPROM.put(20, Wt); 
     }
     
      else if (KEY == 1){
      item = 2;
      lcd.clear();
     } 
      else if (KEY == 3){
      item = 0; 
      lcd.clear();
     } 
  }
//режим отбор тела окончен


//______________МЕНЮ____________________________________________________________________________________________________________________________________

// выбор основного режима работы колонны (главное меню)
     
    else  if (item == 10 && menuLevel == 1) // прямой перегон
  {    
  lcd.setCursor(0, 0);
  lcd.print("->"); 
  lcd.print(L"СЫРЕЦ"); 
  lcd.setCursor(7, 0);
  lcd.print("   "); 
  lcd.print(L"ГОЛОВЫ");
  lcd.setCursor(0, 1);
  lcd.print("  "); 
  lcd.print(L"ТЕЛО");
  lcd.print("    "); 
  lcd.print(L"ХВОСТ");

    if (KEY == 3) { // если нажата кнопка
    menuLevel = 2;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     }
    if (KEY == 4) { // если нажата кнопка
    menuLevel = 3;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     }
    if (KEY == 5){
    item = 0;
    lcd.clear();
    } 
   }
   
 else  if (item == 10 && menuLevel == 2) // отбор голов
  {    
  lcd.setCursor(0, 0);
  lcd.print("  "); 
  lcd.print(L"СЫРЕЦ"); 
  lcd.setCursor(7, 0);
  lcd.print(" ->"); 
  lcd.print(L"ГОЛОВЫ");
  lcd.setCursor(0, 1);
  lcd.print("  "); 
  lcd.print(L"ТЕЛО");
  lcd.print("    "); 
  lcd.print(L"ХВОСТ");

    if (KEY == 1) { // если нажата кнопка
    menuLevel = 1;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     }
    if (KEY == 4) { // если нажата кнопка
    menuLevel = 4;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     }
    if (KEY == 5){
    item = 0;
    lcd.clear();
    } 
   }

   
 else if (item == 10 && menuLevel == 3) // отбор тела
  {    
  lcd.setCursor(0, 0);
  lcd.print("  "); 
  lcd.print(L"СЫРЕЦ");
  lcd.setCursor(7, 0);
  lcd.print("   "); 
  lcd.print(L"ГОЛОВЫ");
  lcd.setCursor(0, 1);
  lcd.print("->"); 
  lcd.print(L"ТЕЛО");
  lcd.print("    "); 
  lcd.print(L"ХВОСТ");

    if (KEY == 3) { // если нажата кнопка
    menuLevel = 4;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     }
    if (KEY == 2) { // если нажата кнопка
    menuLevel = 1;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     } 
    if (KEY == 5){
    item = 0;
    lcd.clear();
    } 
   }

   
 else if (item == 10 && menuLevel == 4) // отбор хвостов
  {    
  lcd.setCursor(0, 0);
  lcd.print("  "); 
  lcd.print(L"СЫРЕЦ");
  lcd.setCursor(7, 0);
  lcd.print("   "); 
  lcd.print(L"ГОЛОВЫ");
  lcd.setCursor(0, 1);
  lcd.print("  "); 
  lcd.print(L"ТЕЛО");
  lcd.print("  ->"); 
  lcd.print(L"ХВОСТ");

    if (KEY == 1) { // если нажата кнопка
    menuLevel = 3;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     }
    if (KEY == 2) { // если нажата кнопка
    menuLevel = 2;
    EEPROM.put(25, menuLevel); 
    lcd.clear();
     } 
    if (KEY == 5){
    item = 0;
    lcd.clear();
    } 
   }
  //выбор режима колонны окончен
  

//_______СЫРЕЦ_______________________________________________________________________________________________________________________________________________________________________________

  // режим работы - прямой перегон - сырец
  else if (item == 0 && menuLevel == 1) 
  {
  lcd.setCursor(0, 0); 
  lcd.print (tempSensor[0], 1);  // показываем температуру с датчика
  lcd.setCursor(6, 0); 
  lcd.print(" ");
  lcd.print (tempSensor[1], 1);  // показываем температуру с датчика
  lcd.setCursor(12, 0); 
  lcd.print(" ");
  lcd.print (tempSensor[2], 1);  // показываем температуру с датчика
   
  lcd.setCursor(0, 1);
  int time=millis()/1000;
  lcd.setCursor(6, 1); 
  if ((time/60/60)%60<10) {  lcd.print ("0"); }
  lcd.print (time/60/60);  // час
  lcd.setCursor(8, 1);
  if (time%2 == 1)  lcd.print (":");  
  else   lcd.print (" ");   
  lcd.setCursor(9, 1); 
  if (time/60%60<10) {  lcd.print ("0"); }
  lcd.print ((time/60)%60); 
  if (Serial2.available() > 0) {// вывод на экран реальной мощности
  realI = Serial2.read();  
  WT = realI * 22;       
  lcd.setCursor(11, 1);
  lcd.print (WT);
  lcd.print ("W");
  lcd.print ("    ");  
  }
  
  if (millis() - previousMillis2 >= 1000) { // расчет мощности и отправка значения на МИНИ
  previousMillis2 = millis(); 
  Serial3.print("T  ");
  Serial3.println(tempOUTon[0], 1);
  Serial3.print("t1  ");
  Serial3.println(tempSensor[0], 1);
  Serial3.print("t2  ");
  Serial3.println(tempSensor[1], 1);
  Serial3.print("t3  ");
  Serial3.println(tempSensor[2], 1);
  Serial3.print(WT);
  Serial3.print("w");
  Serial3.println("  ");
 }
    
 // сверяем температуру и управляем ТЭНОМ

  if (tempSensor[2] >= 99 || Tsensorj == 1)  // пищалка // 
  { 
  tone(OUT[2], 2000, 300); // включаем пищалку
  delay (200);
  digitalWrite(OUT[0], HIGH);
  if (millis() - previousMillisI >= 1000) { // расчет тока и отправка значения на МИНИ раз в сек
  previousMillisI = millis(); 
  I = 0; // вычисляем значение тока с округлением  
  Serial2.write(I); // передаем значение на ардумини
  }
  }
  else {noTone(OUT[2]);// выключаем пищалку
  digitalWrite(OUT[0], LOW);
  if (millis() - previousMillisI >= 1000) { // расчет тока и отправка значения на МИНИ раз в сек
  previousMillisI = millis(); 
  I = round(WtPR/22); // вычисляем значение тока с округлением  
  Serial2.write(I); // передаем значение на ардумини
  }
  }
  lcd.setCursor(15, 0);   // рисуем статус выхода клапана      
  if (Tsensorj == 1) lcd.print("!"); // статус тревога
  else  if (digitalRead(OUT[1])) lcd.print(L"К");// статус открыт клапан
  else  if (menuLevel == 1) lcd.print(L"С");// статус отбор голов
  else  if (menuLevel == 2) lcd.print(L"Г");// статус отбор тела
  else  if (menuLevel == 3) lcd.print(L"Т");// статус отбор тела
  else  if (menuLevel == 4) lcd.print(L"Х");// статус отбор тела 
       
  if (KEY == 3){//  шагаем следующее меню
  item = 1;
  lcd.clear();
 } 
  else if (KEY == 5){ // кнопка селект выбор головы или тело
  item = 10;
  lcd.clear();
 }       
 }

  else if (item == 1 && menuLevel == 1) 
 {
  lcd.setCursor(0, 0);
  lcd.print(L"Мощность отбора"); 
  lcd.setCursor(1, 1);
  lcd.print(WtPR);
  lcd.print("Wt  "); 

  if (KEY == 4) { // если нажата кнопка
  WtPR=WtPR-20;   // изменяем значение
  if (WtPR < 1000) WtPR = 2500;
  if (WtPR > 2500) WtPR = 1000;
  EEPROM.put(30, WtPR); // сохраняем в еепром
 }
  else if (KEY == 2){
  WtPR=WtPR+20;
  if (WtPR < 1000) WtPR = 2500;
  if (WtPR > 2500) WtPR = 1000;
  EEPROM.put(30, WtPR); 
 }
  else if (KEY == 1){
  item = 0;
  lcd.clear();
 } 
  else if (KEY == 3){
  item = 0; 
  lcd.clear();
 } 
 }
// режим прямого перегона окончен



//_____________ГОЛОВЫ___________________________________________________________________________________________________________________________________________________________________

// режим отбора голов

  else if (item == 0 && menuLevel == 2) 
  {
  lcd.setCursor(0, 0); 
  lcd.print (tempSensor[0], 1);  // показываем температуру с датчика
    lcd.setCursor(6, 0); 
  //lcd.print("  ");
  lcd.print (tempSensor[1], 1);  // показываем температуру с датчика
  lcd.setCursor(12, 0); 
  //lcd.print("  ");
  lcd.print (tempSensor[2], 1);  // показываем температуру с датчика
    lcd.setCursor(0, 1);
   lcd.print(tempOUTonGO[0], 1); // показываем установленную температуру
     int time=millis()/1000;
lcd.setCursor(6, 1); 
  if ((time/60/60)%60<10) {  lcd.print ("0"); }
  lcd.print (time/60/60);  // час
   lcd.setCursor(8, 1);
  if (time%2 == 1)  lcd.print (":");  
  else   lcd.print (" ");   
    lcd.setCursor(9, 1); 
    if (time/60%60<10) {  lcd.print ("0"); }
  lcd.print ((time/60)%60); 
//  lcd.setCursor(7, 1); 
//    lcd.print(WtGO); 
//      lcd.print("Wt ");  
    
  
 t = tempOUTonGO[0] + 0.2; // значение для включения тревоги при превышении дельты на 0,2 градуса
 
  //// сверяем температуру и управляем выходами

    if (tempSensor[0] >= tempOUTonGO[0] && tempSensor[1] >= tempOUTonGO[1])  digitalWrite(OUT[1], HIGH); // включение клапана
    else digitalWrite(OUT[1], LOW);
    if (tempSensor[1] >= tempOUTonGO[2] || tempSensor[2] >= 99 || tempSensor[0] > t || Tsensorf == 1 || Tsensorh == 1 || Tsensorj == 1)  // пищалка // сенсор 1 температура в самом вверху колонны,// сенсор2 темпер куба.// порог срабатывания тревоги при превышении на 0,2градуса
    { 
      tone(OUT[2], 2000, 300); // включаем пищалку
    delay (300);
    digitalWrite(OUT[2], HIGH);
    }
    else {noTone(OUT[2]);// выключаем пищалку
    digitalWrite(OUT[2], LOW);
   }
  
    lcd.setCursor(14, 1);   // рисуем статус выхода клапана      
  if (digitalRead(OUT[2])) lcd.print("!!"); // статус тревога
  else if (digitalRead(OUT[1])) lcd.print(L"КЛ");// статус открыт клапан
   else  if (menuLevel == 1) lcd.print(L"СР");// статус отбор голов
   else  if (menuLevel == 2) lcd.print(L"ГЛ");// статус отбор тела
     else  if (menuLevel == 3) lcd.print(L"ТЕ");// статус отбор тела
       else  if (menuLevel == 4) lcd.print(L"ХВ");// статус отбор тела
       
  
  // выбор температуры дельты клапана
  
    if (KEY == 4) { // если нажата кнопка
      tempOUTonGO[0]=tempOUTonGO[0]-0.1;   // изменяем значение
        if (tempOUTonGO[0] < 60) tempOUTonGO[0] = 100;
        if (tempOUTonGO[0] > 101) tempOUTonGO[0] = 60;
      EEPROM.put(45, tempOUTonGO[0]); // сохраняем в еепром
   //  delay(150);
     }
     
     else if (KEY == 2){
       tempOUTonGO[0]=tempOUTonGO[0]+0.1;
         if (tempOUTonGO[0] > 101) tempOUTonGO[0] = 60;
         if (tempOUTonGO[0] < 60) tempOUTonGO[0] = 100;
          EEPROM.put(45, tempOUTonGO[0]); 
    // delay(150);
     } 
       
    else if (KEY == 3){//  шагаем следующее меню
      item = 1;
    // delay(350);
     lcd.clear();
     } 
      else if (KEY == 5){ // кнопка селект выбор головы или тело
     //    delay(350);
      item = 10;
         lcd.clear();
     }       
  }
     else if (item == 1 && menuLevel == 2) 
  {
    
    lcd.setCursor(0, 0);
    lcd.print(L"Темпер откл клап"); 

     lcd.setCursor(0, 1);
   lcd.print(" "); 
  lcd.print(tempOUTonGO[1], 1);
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      tempOUTonGO[1]=tempOUTonGO[1]-0.1;   // изменяем значение
        if (tempOUTonGO[1] < 60) tempOUTonGO[1] = 100;
        if (tempOUTonGO[1] > 101) tempOUTonGO[1] = 60;
      EEPROM.put(50, tempOUTonGO[1]); // сохраняем в еепром
   //  delay(150);
     }
     else if (KEY == 2){
       tempOUTonGO[1]=tempOUTonGO[1]+0.1;
         if (tempOUTonGO[1] > 101) tempOUTonGO[1] = 60;
         if (tempOUTonGO[1] < 60) tempOUTonGO[1] = 100;
          EEPROM.put(50, tempOUTonGO[1]); 
   //  delay(150);
     }
       else if (KEY == 1){
      item = 0;
   //  delay(350);
     lcd.clear();
     } 
        else if (KEY == 3){
      item = 2;
    // delay(350);
     lcd.clear();
     } 
   

  }
  else if (item == 2 && menuLevel == 2) //температура out2 // тревога перегрев колонна
  {
    
    lcd.setCursor(0, 0);
     lcd.print(L"Мах Т колонны"); 
     lcd.setCursor(0, 1);
   lcd.print(" "); 
  lcd.print(tempOUTonGO[2], 1);
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      tempOUTonGO[2]=tempOUTonGO[2]-0.1;   // изменяем значение
        if (tempOUTonGO[2] < 60) tempOUTonGO[2] = 101;
        if (tempOUTonGO[2] > 101) tempOUTonGO[2] = 60;
      EEPROM.put(55, tempOUTonGO[2]); // сохраняем в еепром
   //  delay(150);
     }
     else if (KEY == 2){
       tempOUTonGO[2]=tempOUTonGO[2]+0.1;
         if (tempOUTonGO[2] > 101) tempOUTonGO[2] = 60;
         if (tempOUTonGO[2] < 60) tempOUTonGO[2] = 101;
          EEPROM.put(55, tempOUTonGO[2]); 
    // delay(150);
     }
       else if (KEY == 1){
      item = 1;
    // delay(350);
     lcd.clear();
     } 
        else if (KEY == 3){
      item = 3;
    // delay(350);
     lcd.clear();
     } 
    }
    
  else if (item == 3 && menuLevel == 2) //температура out2 //первый экран и выбран 2 элемент
  {
    
    lcd.setCursor(0, 0);
     lcd.print(L"Мощность отбора"); 
     lcd.setCursor(0, 1);
   lcd.print(" "); 
  lcd.print(WtGO);
  lcd.print("Wt "); 
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      WtGO=WtGO-10;   // изменяем значение
       if (WtGO < 100) WtGO = 3000;
        if (WtGO > 3000) WtGO = 100;
      EEPROM.put(35, WtGO); // сохраняем в еепром
     
   //  delay(150);
     }
     else if (KEY == 2){
       WtGO=WtGO+10;
        if (WtGO < 100) WtGO = 3000;
        if (WtGO > 3000) WtGO = 100;
          EEPROM.put(35, WtGO); 
           
   //  delay(150);
     }
       else if (KEY == 1){
      item = 2;
  //   delay(350);
     lcd.clear();
     } 
        else if (KEY == 3){
      //  delay(350);
      item = 0; 
     lcd.clear();
     } 
     }
// отбор голов окончен



//_____ХВОСТЫ______________________________________________________________________________________________________________________________________________________________

// режим обора хвостов
 else if (item == 0 && menuLevel == 4) 
  {
  lcd.setCursor(0, 0); 
  lcd.print (tempSensor[0], 1);  // показываем температуру с датчика
    lcd.setCursor(6, 0); 
  //lcd.print("  ");
  lcd.print (tempSensor[1], 1);  // показываем температуру с датчика
  lcd.setCursor(12, 0); 
  //lcd.print("  ");
  lcd.print (tempSensor[2], 1);  // показываем температуру с датчика
    lcd.setCursor(0, 1);
   lcd.print(tempOUTonHV[0], 1); // показываем установленную температуру
  int time=millis()/1000;
lcd.setCursor(6, 1); 
  if ((time/60/60)%60<10) {  lcd.print ("0"); }
  lcd.print (time/60/60);  // час
   lcd.setCursor(8, 1);
  if (time%2 == 1)  lcd.print (":");  
  else   lcd.print (" ");   
    lcd.setCursor(9, 1); 
    if (time/60%60<10) {  lcd.print ("0"); }
  lcd.print ((time/60)%60); 
  //lcd.print("C "); 
//  lcd.setCursor(7, 1); 
//    lcd.print(WtHV); 
//      lcd.print("Wt ");  
    
  
 //t = tempOUTon[0] + 0.2; // значение для включения тревоги при превышении дельты на 0,2 градуса
 
  //// сверяем температуру и управляем выходами

    if (tempSensor[0] >= tempOUTon[0] && tempSensor[1] >= tempOUTon[1])  digitalWrite(OUT[1], HIGH); // включение клапана
    else digitalWrite(OUT[1], LOW);
    if ( tempSensor[2] >= 99 )  // пищалка 
    { 
      tone(OUT[2], 2000, 300); // включаем пищалку
    delay (300);
    digitalWrite(OUT[0], HIGH);
    }
    else {noTone(OUT[2]);// выключаем пищалку
    digitalWrite(OUT[0], LOW);
   }
  
    lcd.setCursor(14, 1);   // рисуем статус выхода клапана      
  if (digitalRead(OUT[0])) lcd.print("!!"); // статус тревога
  else if (digitalRead(OUT[1])) lcd.print(L"КЛ");// статус открыт клапан
   else  if (menuLevel == 1) lcd.print(L"СР");// статус отбор голов
   else  if (menuLevel == 2) lcd.print(L"ГЛ");// статус отбор тела
     else  if (menuLevel == 3) lcd.print(L"ТЕ");// статус отбор тела
       else  if (menuLevel == 4) lcd.print(L"ХВ");// статус отбор тела
  
  // выбор температуры дельты клапана
  
    if (KEY == 4) { // если нажата кнопка
      tempOUTonHV[0]=tempOUTonHV[0]-0.1;   // изменяем значение
        if (tempOUTonHV[0] < 60) tempOUTonHV[0] = 101;
        if (tempOUTonHV[0] > 101) tempOUTonHV[0] = 60;
      EEPROM.put(60, tempOUTonHV[0]); // сохраняем в еепром
    // delay(150);
     }
     
     else if (KEY == 2){
       tempOUTonHV[0]=tempOUTonHV[0]+0.1;
         if (tempOUTonHV[0] > 101) tempOUTonHV[0] = 60;
         if (tempOUTonHV[0] < 60) tempOUTonHV[0] = 101;
          EEPROM.put(60, tempOUTonHV[0]); 
   //  delay(150);
     } 
       
    else if (KEY == 3){//  шагаем следующее меню
      item = 3;
    // delay(350);
     lcd.clear();
     } 
      else if (KEY == 5){ // кнопка селект выбор головы или тело
       //  delay(350);
      item = 10;
         lcd.clear();
     }       
  }
//   else if (item == 1 && menuLevel == 4) 
//  {
//    
//    lcd.setCursor(0, 0);
//    lcd.print("Temp otkl klapan"); 
//
//     lcd.setCursor(0, 1);
//   lcd.print(" "); 
//  lcd.print(tempOUTon[1], 1);
//     // выбор температуры дельты
//    if (KEY == 4) { // если нажата кнопка
//      tempOUTon[1]=tempOUTon[1]-0.1;   // изменяем значение
//        if (tempOUTon[1] < 60) tempOUTon[1] = 101;
//        if (tempOUTon[1] > 101) tempOUTon[1] = 60;
//      EEPROM.put(8, tempOUTon[1]); // сохраняем в еепром
//     delay(150);
//     }
//     else if (KEY == 2){
//       tempOUTon[1]=tempOUTon[1]+0.1;
//         if (tempOUTon[1] > 101) tempOUTon[1] = 60;
//         if (tempOUTon[1] < 60) tempOUTon[1] = 101;
//          EEPROM.put(8, tempOUTon[1]); 
//     delay(150);
//     }
//       else if (KEY == 1){
//      item = 0;
//     delay(350);
//     lcd.clear();
//     } 
//        else if (KEY == 3){
//      item = 2;
//     delay(350);
//     lcd.clear();
//     } 
//   
//
//  }
//  else if (item == 2 && menuLevel == 4) //температура out2 // тревога перегрев колонна
//  {
//    
//    lcd.setCursor(0, 0);
//     lcd.print("Max temp kolonna"); 
//     lcd.setCursor(0, 1);
//   lcd.print(" "); 
//  lcd.print(tempOUTon[2], 1);
//     // выбор температуры дельты
//    if (KEY == 4) { // если нажата кнопка
//      tempOUTon[2]=tempOUTon[2]-0.1;   // изменяем значение
//        if (tempOUTon[2] < 60) tempOUTon[2] = 101;
//        if (tempOUTon[2] > 101) tempOUTon[2] = 60;
//      EEPROM.put(15, tempOUTon[2]); // сохраняем в еепром
//     delay(150);
//     }
//     else if (KEY == 2){
//       tempOUTon[2]=tempOUTon[2]+0.1;
//         if (tempOUTon[2] > 101) tempOUTon[2] = 60;
//         if (tempOUTon[2] < 60) tempOUTon[2] = 101;
//          EEPROM.put(15, tempOUTon[2]); 
//     delay(150);
//     }
//       else if (KEY == 1){
//      item = 1;
//     delay(350);
//     lcd.clear();
//     } 
//        else if (KEY == 3){
//      item = 3;
//     delay(350);
//     lcd.clear();
//     } 
//    }
    
  else if (item == 3 && menuLevel == 4) //температура out2 //первый экран и выбран 2 элемент
  {
    
    lcd.setCursor(0, 0);
     lcd.print("Moschnost telo"); 
     lcd.setCursor(0, 1);
   lcd.print(" "); 
  lcd.print(WtHV);
  lcd.print("Wt "); 
     // выбор температуры дельты
    if (KEY == 4) { // если нажата кнопка
      WtHV=WtHV-10;   // изменяем значение
       if (WtHV < 100) WtHV = 3000;
        if (WtHV > 3000) WtHV = 100;
      EEPROM.put(40, WtHV); // сохраняем в еепром
     
    // delay(150);
     }
     else if (KEY == 2){
       WtHV=WtHV+10;
        if (WtHV < 100) WtHV = 3000;
        if (WtHV > 3000) WtHV = 100;
          EEPROM.put(40, WtHV); 
           
    // delay(150);
     }
       else if (KEY == 1){
      item = 0;
    // delay(350);
     lcd.clear();
     } 
        else if (KEY == 3){
      //  delay(350);
      item = 0; 
     lcd.clear();
     } 
     }

  
     
     }
    
